//******************************
//oc_modify_generator 0.01
//2007/2/9
//******************************
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, StrUtils, Unit2;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    OD: TOpenDialog;
    SD: TSaveDialog;
    Label1: TLabel;
    Label2: TLabel;
    Memo3: TMemo;
    Button2: TButton;
    Memo1: TMemo;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Edit1Click(Sender: TObject);
    procedure Edit2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
    Vmf1: TVmf;
    Vmf2: TVmf;

    RemoveList: TList;
    AddList: TList;
    ModifyList: TList;

    procedure Seiri;
    procedure CreateChangeList;
    procedure InitModifyList;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
//ModifyXg̏
procedure TForm1.InitModifyList;
var
  a: Integer;
begin
  RemoveList.Pack;
  for a := 0 to RemoveList.Count -1 do
  begin
    TEnt(RemoveList.Items[a]).Free;
    RemoveList.Items[a] := nil;
  end;
  RemoveList.Pack;

  AddList.Pack;
  for a := 0 to AddList.Count -1 do
  begin
    TEnt(AddList.Items[a]).Free;
    AddList.Items[a] := nil;
  end;
  AddList.Pack;

  ModifyList.Pack;
  for a := 0 to ModifyList.Count -1 do
  begin
    TEnt(ModifyList.Items[a]).Free;
    ModifyList.Items[a] := nil;
  end;
  ModifyList.Pack;
end;

//
procedure TForm1.FormCreate(Sender: TObject);
begin
  Vmf1 := TVmf.Create;
  Vmf2 := TVmf.Create;

  RemoveList := TList.Create;
  AddList := TList.Create;
  ModifyList := TList.Create;

end;
//I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Vmf1.Free;
  Vmf2.Free;

  InitModifyList;

  RemoveList.Free;
  AddList.Free;
  ModifyList.Free;
end;

//t@CPI
procedure TForm1.Edit1Click(Sender: TObject);
begin

        if OD.Execute then
        begin
            Edit1.Text := od.FileName;
            Vmf1.LoadVmf(od.Filename);

     //       Memo1.Clear;
            Label1.Caption := IntToStr(Vmf1.EntCount);
 {
            for a := 0 to Vmf1.EntCount -1 do
              for b := 1 to vmf1.Ents[a].EntDataCount do
                Memo1.Lines.add(vmf1.ents[a].ID + ' ' +
                          vmf1.ents[a].classname + ' ' +
                          vmf1.ents[a].Targetname + ' ' +
                          vmf1.ents[a].Origin + ' ' +
                          vmf1.ents[a].entdata[b].key + ' ' +
                          vmf1.ents[a].entdata[b].value);
}
        end;
end;

//t@CQI
procedure TForm1.Edit2Click(Sender: TObject);
begin

        if OD.Execute then
        begin
            Edit2.Text := od.FileName;
            Vmf2.LoadVmf(od.Filename);

        //    Memo2.Clear;
            Label2.Caption := IntToStr(Vmf2.EntCount);
            {
            for a := 0 to Vmf2.EntCount -1 do
              for b := 1 to vmf2.Ents[a].EntDataCount do
                Memo2.Lines.add(vmf2.ents[a].ID + ' ' +
                          vmf2.ents[a].classname + ' ' +
                          vmf2.ents[a].Targetname + ' ' +
                          vmf2.ents[a].Origin + ' ' +
                          vmf2.ents[a].entdata[b].key + ' ' +
                          vmf2.ents[a].entdata[b].value);
              }
        end;
end;

//`FWXg쐬
procedure TForm1.Button1Click(Sender: TObject);
var
  Index1, Index2: Integer;
  DataIndex1, DataIndex2: Integer;
  AddEnt: TEnt;
  DelFrag: Boolean;
begin
  //`FWXg̏
  InitModifyList;

  //Vmf1Ȃ߂
  for Index1 := 0 to Vmf1.EntCount -1 do
  begin
    Index2 := Vmf2.IDtoIndex(Vmf1.Ents[Index1].ID);

    if Index2 = -1 then
    begin
    //VMF1ɗLVMF2ɖꍇ
      //******폜********
      AddEnt := TEnt.Create;
      AddEnt.Assign(Vmf1.Ents[Index1]);
      RemoveList.Add(AddEnt);
    end
    else
    begin
    //VMF1AVMF2ɗLꍇ
      //폜ꂽAEgvbg̃`FbN
      DelFrag := False;
      for DataIndex1 := 1 to Vmf1.Ents[Index1].EntDataCount do
      begin
        if Vmf1.Ents[Index1].EntData[DataIndex1].Section = 'connections' then
        begin
        //AEgvbg̏ꍇ
          if Vmf2.Ents[Index2].CheckEntData(Vmf1.Ents[Index1].EntData[DataIndex1].key, Vmf1.Ents[Index1].EntData[DataIndex1].Value ) <> 0 then
          begin
          //AEgvbg폜܂͕ύXĂꍇ
            DelFrag := True;
          end;
        end;
      end;

      if DelFrag then
      begin
      //Vmf1̃AEgvbg폜Ăꍇ
        //******폜********
        AddEnt := TEnt.Create;
        AddEnt.Assign(Vmf1.Ents[Index1]);
        RemoveList.Add(AddEnt);

        //******ǉ******
        AddEnt := TEnt.Create;
        AddEnt.Assign(Vmf2.Ents[Index2]);
        AddList.Add(AddEnt);

      end
      else
      begin
      //Vmf1̃AEgvbg폜ĂȂꍇ
        AddEnt := TEnt.Create;
        //Vmf1EntDataȂ߂
        for DataIndex1 := 1 to Vmf1.Ents[Index1].EntDataCount do
        begin
          DataIndex2 := Vmf2.Ents[Index2].CheckEntData(Vmf1.Ents[Index1].EntData[DataIndex1].key, Vmf1.Ents[Index1].EntData[DataIndex1].Value );
          if DataIndex2 = -1 then
          begin
          //Vmf1̃L[{l폜Ăꍇ
            AddEnt.EntDataCount := AddEnt.EntDataCount +1;
            AddEnt.EntData[AddEnt.EntDataCount].Key := Vmf1.Ents[Index1].EntData[DataIndex1].Key;
            AddEnt.EntData[AddEnt.EntDataCount].Value := '';

          end;
        end;
        //Vmf2EntDataȂ߂
        for DataIndex2 := 1 to Vmf2.Ents[Index2].EntDataCount do
        begin
          DataIndex1 := Vmf1.Ents[Index1].CheckEntData(Vmf2.Ents[Index2].EntData[DataIndex2].key, Vmf2.Ents[Index2].EntData[DataIndex2].Value );
          if DataIndex1 <> 0 then
          begin
          //Vmf1̐lύX܂̓L[ǉĂꍇ
            AddEnt.EntDataCount := AddEnt.EntDataCount +1;
            AddEnt.EntData[AddEnt.EntDataCount] := Vmf2.Ents[Index2].EntData[DataIndex2];
          end;
        end;

        if AddEnt.EntDataCount = 0 then
          AddEnt.Free
        else
        begin
          AddEnt.KeyKey := Vmf1.Ents[Index1].KeyKey;
          AddEnt.KeyValue := Vmf1.Ents[Index1].KeyValue;
          ModifyList.Add(AddEnt);

        end;
      end;
    end;
  end;

  //Vmf2Ȃ߂
  for Index2 := 0 to Vmf2.EntCount -1 do
  begin
    Index1 := Vmf1.IDtoIndex(Vmf2.Ents[Index2].ID);

    if Index1 = -1 then
    begin
    //Vmf1ɖAVmf2ɂꍇ
      AddEnt := TEnt.Create;
      AddEnt.Assign(Vmf2.Ents[Index2]);
      AddList.Add(AddEnt);
    end;

  end;
  Seiri;
  CreateChangeList;
end;

//Xg𐮗
procedure TForm1.Seiri;
var
  VmfIndex: Integer;
  RemoveIndex: Integer;
  VmfClassCount: Integer;
  VmfClassName: String;
  VmfEntSearchData: TEntSearchData;
  Leave: Boolean;

begin
  //SĂ̓NX폜ĂRemoveɂ܂Ƃ߂
  VmfIndex := 0;
  while VmfIndex < RemoveList.Count do
  begin
    VmfClassName := TEnt(RemoveList.Items[VmfIndex]).ClassName;

    //Vmf2̃GeBeB𐔂
    VmfEntSearchData := Vmf2.EntSearch(VmfClassName, '', '');
    VmfClassCount := VmfEntSearchData.ClassNameCount;

    if VmfClassCount = 0 then
    begin
    //SĂ̓GeBeB폜Ăꍇ
      //GeBeBXg폜
      Leave := True;
      for RemoveIndex := 0 to RemoveList.Count -1 do
      begin
        if TEnt(RemoveList.Items[RemoveIndex]).ClassName = VmfClassName then
        begin
          if Leave then
          begin
            //ŏ̃GeBeB̓L[classnameɂĎc
            TEnt(RemoveList.Items[RemoveIndex]).KeyKey := 'classname';
            TEnt(RemoveList.Items[RemoveIndex]).KeyValue := VmfClassName;
            Leave := false;
          end
          else
          begin
            //QԖڈȍ~̃GeBeB̓Xg폜
            TEnt(RemoveList.Items[RemoveIndex]).free;
            RemoveList.Items[RemoveIndex] := nil;
          end;
        end;
      end;
      RemoveList.Pack;
      VmfIndex := VmfIndex - (VmfClassCount -1);
    end;
    VmfIndex := VmfIndex +1;
  end;
end;

//modify
procedure TForm1.CreateChangeList;
var
  Index: Integer;
  DIndex: Integer;
  MapName: String;
  ClassList, TargetList, OriginList: TStringList;

begin
  ClassList := TStringList.Create;
  TargetList := TStringList.Create;
  OriginList := TStringList.Create;
 try
  Memo3.Clear;
  MapName := ExtractFileName(Edit1.Text);
  MapName := LeftStr(MapName, Pos('.', MapName) -1);



  Memo3.Lines.Add(MapName);
  Memo3.Lines.Add('{');

  if RemoveList.Count > 0 then
  begin
  //RemoveLꍇ
    Memo3.Lines.Add('    Remove');
    Memo3.Lines.Add('    {');
    for Index := 0 to RemoveList.Count -1 do
    begin
      if TEnt(RemoveList.Items[Index]).KeyKey = 'classname' then
        ClassList.Add('            "' + TEnt(RemoveList.Items[Index]).KeyValue + '" {}')
      else
      if TEnt(RemoveList.Items[Index]).KeyKey = 'targetname' then
        TargetList.Add('            "' + TEnt(RemoveList.Items[Index]).KeyValue + '" {}')
      else
      if TEnt(RemoveList.Items[Index]).KeyKey = 'origin' then
        OriginList.Add('            "' + TEnt(RemoveList.Items[Index]).KeyValue + '" {}');

    end;
    if ClassList.Count > 0 then
    begin
    //ClassNameɂ폜ꍇ
      Memo3.Lines.Add('        ClassName');
      Memo3.Lines.Add('        {');
      for Index := 0 to ClassList.Count -1 do
        Memo3.Lines.Add(ClassList.Strings[Index]);
      Memo3.Lines.Add('        }');
    end;

    if TargetList.Count > 0 then
    begin
    //ClassNameɂ폜ꍇ
      Memo3.Lines.Add('        TargetName');
      Memo3.Lines.Add('        {');
      for Index := 0 to TargetList.Count -1 do
        Memo3.Lines.Add(TargetList.Strings[Index]);
      Memo3.Lines.Add('        }');
    end;

    if OriginList.Count > 0 then
    begin
    //ClassNameɂ폜ꍇ
      Memo3.Lines.Add('        Origin');
      Memo3.Lines.Add('        {');
      for Index := 0 to OriginList.Count -1 do
        Memo3.Lines.Add(OriginList.Strings[Index]);
      Memo3.Lines.Add('        }');
    end;
    Memo3.Lines.Add('    }');
  end;

  ClassList.Clear;
  TargetList.Clear;
  OriginList.Clear;


  if AddList.Count > 0 then
  begin
  //AddLꍇ
    Memo3.Lines.Add('    Add');
    Memo3.Lines.Add('    {');
    for Index := 0 to AddList.Count -1 do
    begin
      Memo3.Lines.Add('        "' + TEnt(AddList.Items[Index]).ClassName + '"');
      Memo3.Lines.Add('        {');
      for DIndex := 1 to TEnt(AddList.Items[Index]).EntDataCount do
        if TEnt(AddList.Items[Index]).EntData[DIndex].Key <> 'classname' then
          Memo3.Lines.Add('            "' +
                          TEnt(AddList.Items[Index]).EntData[DIndex].Key + '" "' +
                          TEnt(AddList.Items[Index]).EntData[DIndex].Value + '"');


      Memo3.Lines.Add('        }');
    end;
    Memo3.Lines.Add('    }');
  end;


  if ModifyList.Count > 0 then
  begin
  //ModifyLꍇ
    Memo3.Lines.Add('    Modify');
    Memo3.Lines.Add('    {');
    for Index := 0 to ModifyList.Count -1 do
    begin
      if TEnt(ModifyList.Items[Index]).KeyKey = 'classname' then
      begin
        ClassList.Add('            "' + TEnt(ModifyList.Items[Index]).KeyValue + '"');
        ClassList.Add('            {');
        for DIndex := 1 to TEnt(ModifyList.Items[Index]).EntDataCount do
          ClassList.Add('                "' +
                          TEnt(ModifyList.Items[Index]).EntData[DIndex].Key + '" "' +
                          TEnt(ModifyList.Items[Index]).EntData[DIndex].Value + '"');
        ClassList.Add('            }');
      end
      else
      if TEnt(ModifyList.Items[Index]).KeyKey = 'targetname' then
      begin
        TargetList.Add('            "' + TEnt(ModifyList.Items[Index]).KeyValue + '"');
        TargetList.Add('            {');
        for DIndex := 1 to TEnt(ModifyList.Items[Index]).EntDataCount do
          TargetList.Add('                "' +
                          TEnt(ModifyList.Items[Index]).EntData[DIndex].Key + '" "' +
                          TEnt(ModifyList.Items[Index]).EntData[DIndex].Value + '"');
        TargetList.Add('            }');
      end
      else
      if TEnt(ModifyList.Items[Index]).KeyKey = 'origin' then
      begin
        OriginList.Add('            "' + TEnt(ModifyList.Items[Index]).KeyValue + '"');
        OriginList.Add('            {');
        for DIndex := 1 to TEnt(ModifyList.Items[Index]).EntDataCount do
          OriginList.Add('                "' +
                          TEnt(ModifyList.Items[Index]).EntData[DIndex].Key + '" "' +
                          TEnt(ModifyList.Items[Index]).EntData[DIndex].Value + '"');
        OriginList.Add('            }');
      end;
    end;

    if ClassList.Count > 0 then
    begin
    //ClassNameɂύXꍇ
      Memo3.Lines.Add('        ClassName');
      Memo3.Lines.Add('        {');
      for Index := 0 to ClassList.Count -1 do
        Memo3.Lines.Add(ClassList.Strings[Index]);
      Memo3.Lines.Add('        }');
    end;

    if TargetList.Count > 0 then
    begin
    //ClassNameɂύXꍇ
      Memo3.Lines.Add('        TargetName');
      Memo3.Lines.Add('        {');
      for Index := 0 to TargetList.Count -1 do
        Memo3.Lines.Add(TargetList.Strings[Index]);
      Memo3.Lines.Add('        }');
    end;

    if OriginList.Count > 0 then
    begin
    //ClassNameɂύXꍇ
      Memo3.Lines.Add('        Origin');
      Memo3.Lines.Add('        {');
      for Index := 0 to OriginList.Count -1 do
        Memo3.Lines.Add(OriginList.Strings[Index]);
      Memo3.Lines.Add('        }');
    end;
    Memo3.Lines.Add('    }');
  end;

  ClassList.Clear;
  TargetList.Clear;
  OriginList.Clear;

  for Index := 0 to Memo1.Lines.Count -1 do
    Memo3.Lines.Add(Memo1.Lines[Index]);

  Memo3.Lines.Add('}');

 finally
  ClassList.Free;
  TargetList.Free;
  OriginList.Free;
 end;
end;

//ۑ
procedure TForm1.Button2Click(Sender: TObject);
begin
  SD.FileName := Memo3.Lines.Strings[0] + '_modify.txt';
  if SD.Execute then
  begin
    if FileExists(SD.FileName) then
      if Application.MessageBox('Overwrite?', '', MB_YESNO) <> IDYES then
        Exit;
    Memo3.Lines.SaveToFile(SD.FileName);
  end;
end;

end.
